package com.wywtime.config;

import com.wywtime.datatype.BusiID;
import com.wywtime.datatype.BusiMethodInfo;
import com.wywtime.datatype.DataComb;
import org.reflections.ReflectionUtils;
import org.reflections.Reflections;
import org.reflections.util.ReflectionUtilsPredicates;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

@Configuration
public class BusiIDConfig {

    private Map<String, BusiMethodInfo> methodInfoMap = new HashMap<>();


    @PostConstruct()
    public void init(){
        String basePackage = "com.wywtime.comb";
        Reflections f = new Reflections(basePackage);

        // 获取扫描到的标记注解的集合
        Set<Class<?>> set = f.getTypesAnnotatedWith(DataComb.class);
        for (Class<?> c : set) {
            for(Method method:ReflectionUtils.getMethods(c, ReflectionUtilsPredicates.withAnnotation(BusiID.class))){
                BusiID busiID = method.getAnnotation(BusiID.class);
                methodInfoMap.put(busiID.name(),new BusiMethodInfo(c,method));
            }
        }
    }

    public Map<String, BusiMethodInfo> getMethodInfoMap() {
        return methodInfoMap;
    }

}
